(*
  ˂œ鍏ij
  Easy: 700
  Normal: 1000
  Hard: 1070
  Lunatic: 1200
 *)

type difficulty =
  | Normal
  | Hard
  | Lunatic

let compute_get_fullmoon d bomb =
  let
      bomb_bonus,                       (* c{{[iX *)
      graze_bonus,                      (* {[iX *)
      scb,                              (* XyJ[h{[iX *)
      graze1,                           (* ˖ڂ̂萔 *)
      graze2,                           (* j˖ڂ̂萔 *)
      graze,                            (* ȍ~̂萔 *)
      last_time,                        (* jɓ鍏̐ *)
      final_time_score                  (* iŏIIȁj̓_ *)
      =
    match d with
    | Normal -> 5000000, 500, 21000000, 50, 110, 60, 1600, 11520
    | Hard -> 6000000, 600, 22000000, 55, 115, 65, 1700, 11790
    | Lunatic -> 7500000, 750, 23000000, 60, 120, 70, 1800, 12140 in
  let total_graze = graze1 + graze2 + graze * 12 in
  let total_time = total_graze * 3 + last_time in
  scb + total_graze * (4000 + graze_bonus) + total_time * final_time_score
  + (if bomb < 3 then bomb_bonus else 0)
    (* , total_graze, total_time *)

let compute_bomb_fullmoon d bomb =
  let bomb = min bomb 6 in
  let
      bomb_bonus,
      graze_bonus,
      graze1,
      _graze,
      graze,                            (* ˂̂萔 *)
      last_time,
      time_score,                       (* ̓_ *)
      final_time_score
      =
    match d with
    | Normal -> 5000000, 500, 50, 60, 335, 1600, 5870, 11520
    | Hard -> 6000000, 600, 55, 65, 355, 1700, 5940, 11790
    | Lunatic -> 7500000, 750, 60, 70, 400, 1800, 5990, 12140 in
  let added_graze = graze / 3 in         (* ʉEGrazeɉZi{j *)
  let _total_graze = _graze * ((6 - bomb) * 2) in
  let _total_time = _total_graze * 3 in
  let total_not_added_graze = graze1 + graze * (bomb * 2) in
  let total_added_graze = graze1 + added_graze * bomb in
  let total_hidden_time = graze * 3 * bomb in
  (* {Ă͍𓾂ĂXRAɉZȂ񂾂 *)
  let total_time = graze1 * 3 + graze * 3 * bomb + last_time in
  _total_graze * (4000 + graze_bonus)
  + _total_time * final_time_score
  + total_not_added_graze * 4000 + total_added_graze * graze_bonus
  + total_hidden_time * (final_time_score - time_score)
  + total_time * final_time_score
  - bomb_bonus * bomb + bomb_bonus (* ܖʃNA{[ *)
    (* , _total_graze, _total_time, total_not_added_graze, total_added_graze,
       total_hidden_time, total_time *)
let _ =
  let d = ref Normal in
  let bomb = ref 0 in
  print_endline "^̌̃{҂͂ǂ̂炢҂̂ZovOB";
  let rec loop () =
    print_endline "Փx́Hi[]̒̐́BEnter̂ݑłƏI܂BEasyɂ͑ΉĂ܂j";
    print_endline "[1]Normal [2]Hard [3]Lunatic";
    begin
      match read_line () with
      | "1" ->
          d := Normal;
          print_endline "NormalˁB";
      | "2" ->
          d := Hard;
          print_endline "HardˁB";
      | "3" ->
          d := Lunatic;
          print_endline "LunaticˁB";
      | "" -> exit 0
      | _ ->
          d := Normal;
          print_endline "NormalɂB";
    end;
    print_endline "{͂ƍlH";
    begin
      try
        bomb := int_of_string (read_line ());
      with
        Failure "int_of_string" ->
          bomb := 8;
          print_endline "ĂƂɂ܂B";
    end;
    let get = compute_get_fullmoon !d !bomb in
    let not_get = compute_bomb_fullmoon !d !bomb in
    Printf.printf "{sgp:  %10d_\n" get;
    Printf.printf "{%dgp: %10d_i%+d_j\n\n" (min !bomb 6) not_get (not_get - get);
    loop ();
  in
  loop ()
